diff --git a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
index 3715e98..7a28107 100644
--- a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
+++ b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
@@ -1,23 +1,23 @@
 /*
  * Copyright (c) 2007, Anthony Minessale II
  * All rights reserved.
- * 
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
- * 
+ *
  * * Redistributions of source code must retain the above copyright
  * notice, this list of conditions and the following disclaimer.
- * 
+ *
  * * Redistributions in binary form must reproduce the above copyright
  * notice, this list of conditions and the following disclaimer in the
  * documentation and/or other materials provided with the distribution.
- * 
+ *
  * * Neither the name of the original author; nor the names of any contributors
  * may be used to endorse or promote products derived from this software
  * without specific prior written permission.
- * 
- * 
+ *
+ *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
@@ -30,267 +30,268 @@
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
-/**
- * Workaround for missing u_int / u_short types on solaris
- */
-#if defined(HAVE_LIBPCAP) && defined(__SunOS)
-#define __EXTENSIONS__
+#ifdef HAVE_CONFIG_H
+#include "config.h"
 #endif
+#include <private/ftdm_core.h>
+#include <libisdn/Q931.h>
+#include <libisdn/Q921.h>
 
-#include "private/ftdm_core.h"
-#include "Q931.h"
-#include "Q921.h"
 #ifdef WIN32
 #include <windows.h>
 #else
 #include <sys/time.h>
 #endif
 
-#include "ftdm_isdn.h"
+#include "ftmod_isdn.h"
 
 #define LINE "--------------------------------------------------------------------------------"
-//#define IODEBUG
 
 /* helper macros */
 #define FTDM_SPAN_IS_BRI(x)	((x)->trunk_type == FTDM_TRUNK_BRI || (x)->trunk_type == FTDM_TRUNK_BRI_PTMP)
 #define FTDM_SPAN_IS_NT(x)	(((ftdm_isdn_data_t *)(x)->signal_data)->mode == Q921_NT)
 
+#define DEFAULT_NATIONAL_PREFIX 	"0"
+#define DEFAULT_INTERNATIONAL_PREFIX	"00"
 
-#ifdef HAVE_LIBPCAP
-/*-------------------------------------------------------------------------*/
-/*Q931ToPcap functions*/
+/*****************************************************************************************
+ * PCAP
+ *          Based on Helmut Kuper's (<helmut.kuper@ewetel.de>) implementation,
+ *          but using a different approach (needs a recent libpcap + wireshark)
+ *****************************************************************************************/
+#ifdef HAVE_PCAP
+#include <arpa/inet.h>		/* htons() */
 #include <pcap.h>
-#endif
 
-#define SNAPLEN 1522
-#define MAX_ETHER_PAYLOAD_SIZE 1500
-#define MIN_ETHER_PAYLOAD_SIZE 42
-#define SIZE_ETHERNET           18
-#define VLANID_OFFSET           15
-#define SIZE_IP                 20
-#define SIZE_TCP                20
-#define SIZE_TPKT               4
-#define SIZE_ETHERNET_CRC       4
-#define OVERHEAD                SIZE_ETHERNET+SIZE_IP+SIZE_TCP+SIZE_TPKT
-#define MAX_Q931_SIZE           MAX_ETHER_PAYLOAD_SIZE-SIZE_IP-SIZE_TCP-SIZE_TPKT
-#define TPKT_SIZE_OFFSET        SIZE_ETHERNET+SIZE_IP+SIZE_TCP+2
-#define IP_SIZE_OFFSET          SIZE_ETHERNET+2
-#define TCP_SEQ_OFFSET		SIZE_ETHERNET+SIZE_IP+4
-
-#ifdef HAVE_LIBPCAP
-/*Some globals*/
-unsigned long           pcapfilesize = 0;
-unsigned long		tcp_next_seq_no_send = 0;
-unsigned long           tcp_next_seq_no_rec = 0;
-pcap_dumper_t           *pcapfile    = NULL;
-struct pcap_pkthdr      pcaphdr;
-pcap_t                  *pcaphandle  = NULL;
-char 			*pcapfn      = NULL;
-int			do_q931ToPcap= 0;
-
-/*Predefined Ethernet Frame with Q931-over-IP encapsulated - From remote TDM host to FreeSWITCH*/
-L3UCHAR  recFrame[SNAPLEN]= {
-                                /*IEEE 802.3 VLAN 802.1q Ethernet Frame Header*/
-                                2,0,1,0xAA,0xAA,0xAA,2,0,1,0xBB,0xBB,0xBB,0x81,0,0xE0,0,0x08,0,
-                                /*IPv4 Header (minimal size; no options)*/
-                                0x45,0,0,44,0,0,0,0,64,6,0,0,2,2,2,2,1,1,1,1,
-                                /*TCP-Header*/
-                                0,0x66,0,0x66,0,0,0,0,0,0,0,0,0x50,0,0,1,0,0,0,0,
-                                /*TPKT-Header RFC 1006*/
-                                3,0,0,0
-                            };
-
-/*Predefined Ethernet Frame with Q931-over-IP encapsulated - Frome FreeSWITCH to remote TDM host*/
-L3UCHAR  sendFrame[SNAPLEN]= {
-                                /*IEEE 802.3 VLAN 802.1q Ethernet Frame Header*/
-                                2,0,1,0xBB,0xBB,0xBB,2,0,1,0xAA,0xAA,0xAA,0x81,0,0xE0,0,0x08,0,
-                                /*IPv4 Header (minimal size; no options)*/
-                                0x45,0,0,44,0,0,0,0,64,6,0,0,1,1,1,1,2,2,2,2,
-                                /*TCP-Header*/
-                                0,0x66,0,0x66,0,0,0,0,0,0,0,0,0x50,0,0,1,0,0,0,0,
-                                /*TPKT-Header RFC 1006*/
-                                3,0,0,0
-                             };
+#define PCAP_SNAPLEN	1500
 
-/**
- * \brief Opens a pcap file for capture
- * \return Success or failure
- */
-static ftdm_status_t openPcapFile(void)
+struct pcap_context {
+	pcap_dumper_t		*dump;		/*!< pcap file handle  */
+	pcap_t			*handle;	/*!< pcap lib context  */
+	char			*filename;	/*!< capture file name */
+};
+
+static inline ftdm_status_t isdn_pcap_is_open(struct ftdm_isdn_data *isdn)
 {
-        if(!pcaphandle)
-        {
-                pcaphandle = pcap_open_dead(DLT_EN10MB, SNAPLEN);
-                if (!pcaphandle)
-                {
-                        ftdm_log(FTDM_LOG_ERROR, "Can't open pcap session: (%s)\n", pcap_geterr(pcaphandle));
-                        return FTDM_FAIL;
-                }
-        }
+	return (isdn->pcap) ? 1 : 0;
+}
 
-        if(!pcapfile){
-                /* Open the dump file */
-                if(!(pcapfile=pcap_dump_open(pcaphandle, pcapfn))){
-                        ftdm_log(FTDM_LOG_ERROR, "Error opening output file (%s)\n", pcap_geterr(pcaphandle));
-                        return FTDM_FAIL;
-                }
-        }
-        else{
-                ftdm_log(FTDM_LOG_WARNING, "Pcap file is already open!\n");
-                return FTDM_FAIL;
-        }
+static inline ftdm_status_t isdn_pcap_capture_both(struct ftdm_isdn_data *isdn)
+{
+	return ((isdn->flags & (FTDM_ISDN_CAPTURE | FTDM_ISDN_CAPTURE_L3ONLY)) == FTDM_ISDN_CAPTURE) ? 1 : 0;
+}
 
-        ftdm_log(FTDM_LOG_DEBUG, "Pcap file '%s' successfully opened!\n", pcapfn);
+static inline ftdm_status_t isdn_pcap_capture_l3only(struct ftdm_isdn_data *isdn)
+{
+	return ((isdn->flags & FTDM_ISDN_CAPTURE) && (isdn->flags & FTDM_ISDN_CAPTURE_L3ONLY)) ? 1 : 0;
+}
 
-        pcaphdr.ts.tv_sec  	= 0;
-        pcaphdr.ts.tv_usec 	= 0;
-	pcapfilesize       	= 24;	/*current pcap file header seems to be 24 bytes*/
-	tcp_next_seq_no_send    = 0;
-	tcp_next_seq_no_rec	= 0;
+static ftdm_status_t isdn_pcap_open(struct ftdm_isdn_data *isdn, char *filename)
+{
+	struct pcap_context *pcap = NULL;
 
-        return FTDM_SUCCESS;
+	if (!isdn) {
+		return FTDM_FAIL;
+	}
+
+	if (ftdm_strlen_zero(filename)) {
+		return FTDM_FAIL;
+	}
+
+	pcap = malloc(sizeof(struct pcap_context));
+	if (!pcap) {
+		ftdm_log(FTDM_LOG_ERROR, "Failed to allocate isdn pcap context\n");
+		return FTDM_FAIL;
+	}
+
+	memset(pcap, 0, sizeof(struct pcap_context));
+
+	pcap->filename = strdup(filename);
+
+	pcap->handle = pcap_open_dead(DLT_LINUX_LAPD, PCAP_SNAPLEN);
+	if (!pcap->handle) {
+		ftdm_log(FTDM_LOG_ERROR, "Failed to open pcap handle\n");
+		goto error;
+	}
+
+	pcap->dump = pcap_dump_open(pcap->handle, pcap->filename);
+	if (!pcap->dump) {
+		ftdm_log(FTDM_LOG_ERROR, "Failed to open capture file: %s\n", pcap_geterr(pcap->handle));
+		goto error;
+	}
+
+	ftdm_log(FTDM_LOG_INFO, "Capture file \"%s\" opened\n", pcap->filename);
+
+	isdn->pcap = pcap;
+
+	return FTDM_SUCCESS;
+
+error:
+	if (pcap->handle) {
+		pcap_close(pcap->handle);
+	}
+	if (pcap->filename) {
+		free(pcap->filename);
+	}
+
+	free(pcap);
+
+	return FTDM_FAIL;
 }
 
-/**
- * \brief Closes a pcap file
- * \return Success
- */
-static ftdm_status_t closePcapFile(void)
+static ftdm_status_t isdn_pcap_close(struct ftdm_isdn_data *isdn)
 {
-	if (pcapfile) {
-		pcap_dump_close(pcapfile);
-		if (pcaphandle) pcap_close(pcaphandle);
-
-		ftdm_log(FTDM_LOG_DEBUG, "Pcap file closed! File size is %lu bytes.\n", pcapfilesize);
+	struct pcap_context *pcap = NULL;
+	long size;
 
-		pcaphdr.ts.tv_sec 	= 0;
-		pcaphdr.ts.tv_usec 	= 0;
-		pcapfile		= NULL;
-		pcaphandle 		= NULL;
-		pcapfilesize		= 0;
-		tcp_next_seq_no_send	= 0;
-		tcp_next_seq_no_rec	= 0;
+	if (!isdn || !isdn->pcap) {
+		return FTDM_FAIL;
 	}
+	pcap = isdn->pcap;
+
+	isdn->flags &= ~(FTDM_ISDN_CAPTURE | FTDM_ISDN_CAPTURE_L3ONLY);
+	isdn->pcap   = NULL;
+
+	pcap_dump_flush(pcap->dump);
+
+	size = pcap_dump_ftell(pcap->dump);
+	ftdm_log(FTDM_LOG_INFO, "File \"%s\" captured %ld bytes of data\n", pcap->filename, size);
+
+	pcap_dump_close(pcap->dump);
+	pcap_close(pcap->handle);
+
+	free(pcap->filename);
+	free(pcap);
 
-	/*We have allways success with this? I think so*/
 	return FTDM_SUCCESS;
 }
 
-/**
- * \brief Writes a Q931 packet to a pcap file
- * \return Success or failure
- */
-static ftdm_status_t writeQ931PacketToPcap(L3UCHAR* q931buf, L3USHORT q931size, L3ULONG span_id, L3USHORT direction)
+static inline void isdn_pcap_start(struct ftdm_isdn_data *isdn)
 {
-        L3UCHAR                 *frame		= NULL;
-	struct timeval		ts;
-	u_char			spanid		= (u_char)span_id;
-	unsigned long 		*tcp_next_seq_no = NULL;
-
-	spanid=span_id;
-	
-        /*The total length of the ethernet frame generated by this function has a min length of 66
-        so we don't have to care about padding :)*/
-
-
-        /*FS is sending the packet*/
-        if(direction==0){
-		frame=sendFrame;
-		tcp_next_seq_no = &tcp_next_seq_no_send;
-        } 
-	/*FS is receiving the packet*/
-	else{
-		frame=recFrame;
-		tcp_next_seq_no = &tcp_next_seq_no_rec;
-	}
-
-	/*Set spanid in VLAN-ID tag*/
-        frame[VLANID_OFFSET]    = spanid;
-
-        /*** Write sent packet ***/
-        if(q931size > MAX_Q931_SIZE)
-        {
-                /*WARNING*/
-		ftdm_log(FTDM_LOG_WARNING, "Q931 packet size is too big (%u)! Ignoring it!\n", q931size);
-                return FTDM_FAIL;
-        }
+	if (!isdn->pcap)
+		return;
 
-	/*Copy q931 buffer into frame*/
-        memcpy(frame+OVERHEAD,q931buf,q931size);
+	isdn->flags |= FTDM_ISDN_CAPTURE;
+}
 
-	/*Store TCP sequence number in TCP header*/
-	frame[TCP_SEQ_OFFSET]=(*tcp_next_seq_no>>24)&0xFF;
-	frame[TCP_SEQ_OFFSET+1]=(*tcp_next_seq_no>>16)&0xFF;
-	frame[TCP_SEQ_OFFSET+2]=(*tcp_next_seq_no>>8)&0xFF;
-	frame[TCP_SEQ_OFFSET+3]=*tcp_next_seq_no & 0xFF;
+static inline void isdn_pcap_stop(struct ftdm_isdn_data *isdn)
+{
+	isdn->flags &= ~FTDM_ISDN_CAPTURE;
+}
+
+#ifndef ETH_P_LAPD
+#define ETH_P_LAPD 0x0030
+#endif
 
-        /*Store size of TPKT packet*/
-        q931size+=4;
-        frame[TPKT_SIZE_OFFSET]=(q931size>>8)&0xFF;
-        frame[TPKT_SIZE_OFFSET+1]=q931size&0xFF;
+struct isdn_sll_hdr {
+	uint16_t slltype;
+	uint16_t sllhatype;
+	uint16_t slladdrlen;
+	uint8_t  slladdr[8];
+	uint16_t sllproto;
+};
 
-	/*Calc next TCP sequence number*/
-	*tcp_next_seq_no+=q931size;
+/* Fake Q.921 I-frame */
+//static const char q921_fake_frame[] = { 0x00, 0x00, 0x00, 0x00 };
 
-        /*Store size of IP packet*/
-        q931size+=SIZE_IP+SIZE_TCP;
-        frame[IP_SIZE_OFFSET]=(q931size>>8)&0xFF;
-        frame[IP_SIZE_OFFSET+1]=q931size&0xFF;
+enum {
+	ISDN_PCAP_INCOMING = 0,
+	ISDN_PCAP_INCOMING_BCAST = 1,
+	ISDN_PCAP_OUTGOING = 4,
+};
 
-        pcaphdr.caplen = SIZE_ETHERNET+SIZE_ETHERNET_CRC+q931size;
-        pcaphdr.len = pcaphdr.caplen;
+static ftdm_status_t isdn_pcap_write(struct ftdm_isdn_data *isdn, unsigned char *buf, ftdm_ssize_t len, int direction)
+{
+	unsigned char frame[PCAP_SNAPLEN];
+	struct pcap_context *pcap;
+	struct isdn_sll_hdr *sll_hdr = (struct isdn_sll_hdr *)frame;
+	struct pcap_pkthdr hdr;
+	int offset = sizeof(struct isdn_sll_hdr);
+	int nbytes;
+
+	if (!isdn || !isdn->pcap || !buf || !len) {
+		return FTDM_FAIL;
+	}
 
-        /* Set Timestamp */
-        /* Get Time in ms. usecs would be better ...  */
-        gettimeofday(&ts, NULL);
-        /*Write it into packet header*/
-        pcaphdr.ts.tv_sec = ts.tv_sec;
-        pcaphdr.ts.tv_usec = ts.tv_usec;
+	pcap = isdn->pcap;
+
+	/* Update SLL header */
+	sll_hdr->slltype    = htons(direction);
+	sll_hdr->sllhatype  = 0;
+	sll_hdr->slladdrlen = 1;
+	sll_hdr->slladdr[0] = (isdn->mode == Q921_NT) ? 1 : 0;	/* TODO: NT/TE */
+	sll_hdr->sllproto   = htons(ETH_P_LAPD);
+
+#if 0
+	/* Q.931-only mode: copy fake Q.921 header */
+	if (isdn->flags & FTDM_ISDN_CAPTURE_L3ONLY) {
+		/* copy fake q921 header */
+		memcpy(frame + offset, q921_fake_frame, sizeof(q921_fake_frame));
+		offset += sizeof(q921_fake_frame);
+	}
+#endif
 
-	pcap_dump((u_char*)pcapfile, &pcaphdr, frame);
-        pcap_dump_flush(pcapfile);
+	/* Copy data */
+	nbytes = (len > (PCAP_SNAPLEN - offset)) ? (PCAP_SNAPLEN - offset) : len;
+	memcpy(frame + offset, buf, nbytes);
 
-        /*Maintain pcap file size*/
-        pcapfilesize+=pcaphdr.caplen;
-        pcapfilesize+=sizeof(struct pcap_pkthdr);
+	/* Update timestamp */
+	memset(&hdr, 0, sizeof(struct pcap_pkthdr));
+	gettimeofday(&hdr.ts, NULL);
+	hdr.caplen = offset + nbytes;
+	hdr.len    = hdr.caplen;
 
-	ftdm_log(FTDM_LOG_DEBUG, "Added %u bytes to pcap file. File size is now %lu, \n", q931size, pcapfilesize);
+	/* Write packet */
+	pcap_dump((unsigned char *)pcap->dump, &hdr, frame);
 
-        return FTDM_SUCCESS;
+	return FTDM_SUCCESS;
 }
+#endif	/* HAVE_PCAP */
 
-#endif
+
+static L2ULONG ftdm_time_now(void)
+{
+	return (L2ULONG)ftdm_current_time_in_ms();
+}
 
 /**
- * \brief Unloads pcap IO
- * \return Success or failure
+ * \brief	Returns the signalling status on a channel
+ * \param	ftdmchan	Channel to get status on
+ * \param	status		Pointer to set signalling status
+ * \return	Success or failure
  */
-static FIO_IO_UNLOAD_FUNCTION(close_pcap)
+static FIO_CHANNEL_GET_SIG_STATUS_FUNCTION(isdn_get_channel_sig_status)
 {
-#ifdef HAVE_LIBPCAP
-	return closePcapFile();
-#else
+	*status = FTDM_SIG_STATE_DOWN;
+
+	ftdm_isdn_data_t *isdn_data = ftdmchan->span->signal_data;
+	if (ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
+		*status = FTDM_SIG_STATE_UP;
+	}
 	return FTDM_SUCCESS;
-#endif
 }
 
-/*Q931ToPcap functions DONE*/
-/*-------------------------------------------------------------------------*/
-
 /**
- * \brief Gets current time
- * \return Current time (in ms)
+ * \brief	Returns the signalling status on a span
+ * \param	span	Span to get status on
+ * \param	status	Pointer to set signalling status
+ * \return	Success or failure
  */
-static L2ULONG ftdm_time_now(void)
+static FIO_SPAN_GET_SIG_STATUS_FUNCTION(isdn_get_span_sig_status)
 {
-	return (L2ULONG)ftdm_current_time_in_ms();
+	*status = FTDM_SIG_STATE_DOWN;
+
+	ftdm_isdn_data_t *isdn_data = span->signal_data;
+	if (ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
+		*status = FTDM_SIG_STATE_UP;
+	}
+	return FTDM_SUCCESS;
 }
 
 /**
- * \brief Initialises an ISDN channel (outgoing call)
- * \param ftdmchan Channel to initiate call on
- * \return Success or failure
+ * \brief	Create outgoing channel
+ * \param	ftdmchan	Channel to create outgoing call on
+ * \return	Success or failure
  */
 static FIO_CHANNEL_OUTGOING_CALL_FUNCTION(isdn_outgoing_call)
 {
@@ -301,14 +302,12 @@ static FIO_CHANNEL_OUTGOING_CALL_FUNCTION(isdn_outgoing_call)
 }
 
 /**
- * \brief Requests an ISDN channel on a span (outgoing call)
- * \param span Span where to get a channel
- * \param chan_id Specific channel to get (0 for any)
- * \param direction Call direction (inbound, outbound)
- * \param caller_data Caller information
- * \param ftdmchan Channel to initialise
- * \return Success or failure
+ * \brief	Create outgoing channel, let module select the channel to use
+ * \param	span		Span to create outgoing call on
+ * \param	caller_data
+ * \return	Success or failure
  */
+#ifdef __TODO__
 static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 {
 	Q931mes_Generic *gen = (Q931mes_Generic *) caller_data->raw_data;
@@ -348,7 +347,7 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	BearerCap.ITR       = Q931_ITR_64K;		/* 64k */
 	BearerCap.Layer1Ident = 1;
 	BearerCap.UIL1Prot = (codec == FTDM_CODEC_ALAW) ? Q931_UIL1P_G711A : Q931_UIL1P_G711U;	/* U-law = 2, A-law = 3 */
-	gen->BearerCap = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &BearerCap);
+	gen->BearerCap = Q931AppendIE(gen, (L3UCHAR *) &BearerCap);
 
 	/*
 	 * Channel ID IE
@@ -356,20 +355,20 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	Q931InitIEChanID(&ChanID);
 	ChanID.IntType = FTDM_SPAN_IS_BRI(span) ? 0 : 1;		/* PRI = 1, BRI = 0 */
 
-	if(!FTDM_SPAN_IS_NT(span)) {
+	if (!FTDM_SPAN_IS_NT(span)) {
 		ChanID.PrefExcl = (isdn_data->opts & FTDM_ISDN_OPT_SUGGEST_CHANNEL) ? 0 : 1; /* 0 = preferred, 1 exclusive */
 	} else {
 		ChanID.PrefExcl = 1;	/* always exclusive in NT-mode */
 	}
 
-	if(ChanID.IntType) {
+	if (ChanID.IntType) {
 		ChanID.InfoChanSel = 1;				/* None = 0, See Slot = 1, Any = 3 */
 		ChanID.ChanMapType = 3; 			/* B-Chan */
 		ChanID.ChanSlot = (unsigned char)chan_id;
 	} else {
 		ChanID.InfoChanSel = (unsigned char)chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
 	}
-	gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
+	gen->ChanID = Q931AppendIE(gen, (L3UCHAR *) &ChanID);
 
 	/*
 	 * Progress IE
@@ -378,15 +377,15 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	Progress.CodStand = Q931_CODING_ITU;	/* 0 = ITU */
 	Progress.Location = 0;  /* 0 = User, 1 = Private Network */
 	Progress.ProgDesc = 3;	/* 1 = Not end-to-end ISDN */
-	gen->ProgInd = Q931AppendIE((L3UCHAR *)gen, (L3UCHAR *)&Progress);
+	gen->ProgInd = Q931AppendIE(gen, (L3UCHAR *)&Progress);
 
 	/*
 	 * Display IE
 	 */
-	if (!(isdn_data->opts & FTDM_ISDN_OPT_OMIT_DISPLAY_IE)) {
+	if (!(isdn_data->opts & FTDM_ISDN_OPT_OMIT_DISPLAY_IE) && FTDM_SPAN_IS_NT(span)) {
 		Q931InitIEDisplay(&Display);
 		Display.Size = Display.Size + (unsigned char)strlen(caller_data->cid_name);
-		gen->Display = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &Display);			
+		gen->Display = Q931AppendIE(gen, (L3UCHAR *) &Display);
 		ptrDisplay = Q931GetIEPtr(gen->Display, gen->buf);
 		ftdm_copy_string((char *)ptrDisplay->Display, caller_data->cid_name, strlen(caller_data->cid_name)+1);
 	}
@@ -400,7 +399,7 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	CallingNum.PresInd   = Q931_PRES_ALLOWED;
 	CallingNum.ScreenInd = Q931_SCREEN_USER_NOT_SCREENED;
 	CallingNum.Size = CallingNum.Size + (unsigned char)strlen(caller_data->cid_num.digits);
-	gen->CallingNum = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &CallingNum);			
+	gen->CallingNum = Q931AppendIE(gen, (L3UCHAR *) &CallingNum);
 	ptrCallingNum = Q931GetIEPtr(gen->CallingNum, gen->buf);
 	ftdm_copy_string((char *)ptrCallingNum->Digit, caller_data->cid_num.digits, strlen(caller_data->cid_num.digits)+1);
 
@@ -411,10 +410,10 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	Q931InitIECalledNum(&CalledNum);
 	CalledNum.TypNum    = Q931_TON_UNKNOWN;
 	CalledNum.NumPlanID = Q931_NUMPLAN_E164;
-	CalledNum.Size = CalledNum.Size + (unsigned char)strlen(caller_data->dnis.digits);
-	gen->CalledNum = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &CalledNum);
+	CalledNum.Size = CalledNum.Size + (unsigned char)strlen(caller_data->ani.digits);
+	gen->CalledNum = Q931AppendIE(gen, (L3UCHAR *) &CalledNum);
 	ptrCalledNum = Q931GetIEPtr(gen->CalledNum, gen->buf);
-	ftdm_copy_string((char *)ptrCalledNum->Digit, caller_data->dnis.digits, strlen(caller_data->dnis.digits)+1);
+	ftdm_copy_string((char *)ptrCalledNum->Digit, caller_data->ani.digits, strlen(caller_data->ani.digits)+1);
 
 	/*
 	 * High-Layer Compatibility IE   (Note: Required for AVM FritzBox)
@@ -424,28 +423,28 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 	HLComp.Interpret = 4;	/* only possible value */
 	HLComp.PresMeth  = 1;   /* High-layer protocol profile */
 	HLComp.HLCharID  = 1;	/* Telephony = 1, Fax G2+3 = 4, Fax G4 = 65 (Class I)/ 68 (Class II or III) */
-	gen->HLComp = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &HLComp);
+	gen->HLComp = Q931AppendIE(gen, (L3UCHAR *) &HLComp);
 
 	caller_data->call_state = FTDM_CALLER_STATE_DIALING;
-	Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
-	
+	Q931Rx43(&isdn_data->q931, gen, gen->Size);
+
 	isdn_data->outbound_crv[gen->CRV] = caller_data;
 	//isdn_data->channels_local_crv[gen->CRV] = ftdmchan;
 
 	while(ftdm_running() && caller_data->call_state == FTDM_CALLER_STATE_DIALING) {
 		ftdm_sleep(1);
-		
+
 		if (!--sanity) {
 			caller_data->call_state = FTDM_CALLER_STATE_FAIL;
 			break;
 		}
 	}
 	isdn_data->outbound_crv[gen->CRV] = NULL;
-	
+
 	if (caller_data->call_state == FTDM_CALLER_STATE_SUCCESS) {
 		ftdm_channel_t *new_chan = NULL;
 		int fail = 1;
-		
+
 		new_chan = NULL;
 		if (caller_data->chan_id < FTDM_MAX_CHANNELS_SPAN && caller_data->chan_id <= span->chan_count) {
 			new_chan = span->channels[caller_data->chan_id];
@@ -456,7 +455,7 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 				if (new_chan->state == FTDM_CHANNEL_STATE_DOWN || new_chan->state >= FTDM_CHANNEL_STATE_TERMINATING) {
 					int x = 0;
 					ftdm_log(FTDM_LOG_WARNING, "Channel %d:%d ~ %d:%d is already in use waiting for it to become available.\n");
-					
+
 					for (x = 0; x < 200; x++) {
 						if (!ftdm_test_flag(new_chan, FTDM_CHANNEL_INUSE)) {
 							break;
@@ -493,9 +492,9 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 				}
 
 				fail = 0;
-			} 
+			}
 		}
-		
+
 		if (!fail) {
 			*ftdmchan = new_chan;
 			return FTDM_SUCCESS;
@@ -510,13 +509,13 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 			//should we be casting here.. or do we need to translate value?
 			cause.Value = (unsigned char) FTDM_CAUSE_WRONG_CALL_STATE;
 			*cause.Diag = '\0';
-			gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-			Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+			gen->Cause = Q931AppendIE(gen, (L3UCHAR *) &cause);
+			Q931Rx43(&isdn_data->q931, gen, gen->Size);
 
 			if (gen->CRV) {
 				Q931ReleaseCRV(&isdn_data->q931, gen->CRV);
 			}
-			
+
 			if (new_chan) {
 				ftdm_log(FTDM_LOG_CRIT, "Channel is busy\n");
 			} else {
@@ -524,20 +523,13 @@ static FIO_CHANNEL_REQUEST_FUNCTION(isdn_channel_request)
 			}
 		}
 	}
-	
+
 	*ftdmchan = NULL;
 	return FTDM_FAIL;
 
 }
+#endif /* __TODO__ */
 
-/**
- * \brief Handler for Q931 error
- * \param pvt Private structure (span?)
- * \param id Error number
- * \param p1 ??
- * \param p2 ??
- * \return 0
- */
 static L3INT ftdm_isdn_931_err(void *pvt, L3INT id, L3INT p1, L3INT p2)
 {
 	ftdm_log(FTDM_LOG_ERROR, "ERROR: [%s] [%d] [%d]\n", q931_error_to_name(id), p1, p2);
@@ -545,21 +537,218 @@ static L3INT ftdm_isdn_931_err(void *pvt, L3INT id, L3INT p1, L3INT p2)
 }
 
 /**
- * \brief Handler for Q931 event message
- * \param pvt Span to handle
- * \param msg Message string
- * \param mlen Message string length
- * \return 0
+ * \brief	The new call event handler
+ * \note	W000t!!! \o/  ;D
+ * \todo	A lot
+ */
+static void ftdm_isdn_call_event(struct Q931_Call *call, struct Q931_CallEvent *event, void *priv)
+{
+	Q931_TrunkInfo_t *trunk = NULL;
+	ftdm_isdn_data_t *isdn_data = NULL;
+	ftdm_span_t *zspan = NULL;
+	assert(call);
+	assert(event);
+
+	trunk = Q931CallGetTrunk(call);
+	assert(trunk);
+
+	zspan = Q931CallGetPrivate(call);
+	if (!zspan) {
+		zspan = priv;
+		Q931CallSetPrivate(call, zspan);
+	}
+	assert(zspan);
+
+	isdn_data = zspan->signal_data;
+
+	if (Q931CallIsGlobal(call)) {
+		/*
+		 * Global event
+		 */
+
+		ftdm_log(FTDM_LOG_DEBUG, "Received global event from Q.931\n");
+	}
+	else {
+		ftdm_channel_t *ftdmchan = NULL;
+		ftdm_sigmsg_t sig;
+		int call_crv = Q931CallGetCRV(call);
+		int type;
+
+		/*
+		 * Call-specific event
+		 */
+		ftdm_log(FTDM_LOG_DEBUG, "Received call-specific event from Q.931 for call %d [%hu]\n", Q931CallGetCRV(call), Q931CallGetCRV(call));
+
+		/*
+		 * Try to get associated zap channel
+		 * and init sigmsg struct if there is one
+		 */
+		ftdmchan = Q931CallIsOutgoing(call) ? isdn_data->channels_local_crv[call_crv] : isdn_data->channels_remote_crv[call_crv];
+		if (ftdmchan) {
+			memset(&sig, 0, sizeof(ftdm_sigmsg_t));
+			sig.chan_id = ftdmchan->chan_id;
+			sig.span_id = ftdmchan->span_id;
+			sig.channel = ftdmchan;
+		}
+
+		type = Q931CallEventGetType(event);
+
+		if (type == Q931_EVENT_TYPE_CRV) {
+
+			ftdm_log(FTDM_LOG_DEBUG, "\tCRV event\n");
+
+			switch (Q931CallEventGetId(event)) {
+			case Q931_EVENT_RELEASE_CRV:
+				{
+					/* WARNING contains old interface code, yuck! */
+					if (!ftdmchan) {
+						ftdm_log(FTDM_LOG_DEBUG, "Call %d [0x%x] not associated to zap channel\n", call_crv, call_crv);
+						return;
+					}
+
+					if (ftdmchan->state != FTDM_CHANNEL_STATE_DOWN) {
+						ftdm_log(FTDM_LOG_DEBUG, "Channel %d:%d not in DOWN state, cleaning up\n",
+											ftdmchan->span_id, ftdmchan->chan_id);
+
+						/*
+						 * Send hangup signal to mod_openzap
+						 */
+						if (!sig.channel->caller_data.hangup_cause) {
+							sig.channel->caller_data.hangup_cause = FTDM_CAUSE_NORMAL_CLEARING;
+						}
+
+						sig.event_id = FTDM_SIGEVENT_STOP;
+						isdn_data->sig_cb(&sig);
+
+						/* Release zap channel */
+						ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_DOWN);
+					}
+					return;
+				}
+				break;
+			default:
+				ftdm_log(FTDM_LOG_ERROR, "Unknown CRV event: %d\n", Q931CallEventGetId(event));
+				return;
+			}
+		}
+		else if (type == Q931_EVENT_TYPE_TIMER) {
+			struct Q931_CallTimerEvent *timer_evt = Q931CallEventGetData(event);
+
+			ftdm_log(FTDM_LOG_DEBUG, "\tTimer event\n");
+			assert(timer_evt->id);
+
+			switch (timer_evt->id) {
+			case Q931_TIMER_T303:
+				/*
+				 * SETUP timeout
+				 *
+				 * TE-mode: Q931_EVENT_SETUP_CONFIRM (error)
+				 * NT-mode: Q931_EVENT_RELEASE_INDICATION
+				 */
+				{
+					/* WARNING contains old interface code, yuck! */
+					if (!ftdmchan) {
+						ftdm_log(FTDM_LOG_ERROR, "Call %d [0x%x] not associated to zap channel\n", call_crv, call_crv);
+						return;
+					}
+
+					ftdm_log(FTDM_LOG_DEBUG, "Call setup failed on channel %d:%d\n", ftdmchan->span_id, ftdmchan->chan_id);
+
+					/*
+					 * Send signal to mod_openzap
+					 */
+					sig.channel->caller_data.hangup_cause = FTDM_CAUSE_NETWORK_OUT_OF_ORDER;
+
+					sig.event_id = FTDM_SIGEVENT_STOP;
+					isdn_data->sig_cb(&sig);
+
+					/* Release zap channel */
+					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_DOWN);
+					return;
+				}
+				break;
+
+			default:
+				ftdm_log(FTDM_LOG_ERROR, "Unhandled timer event %d\n", timer_evt->id);
+			}
+		}
+		else if (type == Q931_EVENT_TYPE_MESSAGE) {
+			struct Q931_CallMessageEvent *msg_evt = Q931CallEventGetData(event);
+
+			ftdm_log(FTDM_LOG_DEBUG, "\tMessage event\n");
+			assert(msg_evt);
+
+			/*
+			 * Slowly move stuff from the old event handler into this part...
+			 */
+			switch (Q931CallEventGetId(event)) {
+			case Q931_EVENT_SETUP_CONFIRM:
+			case Q931_EVENT_SETUP_COMPLETE_INDICATION:	/* CONNECT */
+				{
+					/* WARNING contains old interface code, yuck! */
+					if (!ftdmchan) {
+						ftdm_log(FTDM_LOG_ERROR, "Call %d [0x%x] not associated to zap channel\n", call_crv, call_crv);
+						return;
+					}
+					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_UP);
+				}
+				break;
+
+			default:
+				ftdm_log(FTDM_LOG_DEBUG, "Not yet handled message event %d\n", Q931CallEventGetId(event));
+			}
+		}
+		else {
+			ftdm_log(FTDM_LOG_ERROR, "Unknown event type %d\n", type);
+		}
+	}
+}
+
+/**
+ * Copy callednum, readding prefix as needed
  */
-static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
+static void __isdn_get_number(const char *digits, const int ton, char *buf, int size)
+{
+	int offset = 0;
+
+	if (!digits || !buf || size <= 0) {
+		return;
+	}
+
+	switch (ton) {
+	case Q931_TON_NATIONAL:
+		offset = strlen(DEFAULT_NATIONAL_PREFIX);
+		memcpy(buf, DEFAULT_NATIONAL_PREFIX, offset);
+		break;
+	case Q931_TON_INTERNATIONAL:
+		offset = strlen(DEFAULT_INTERNATIONAL_PREFIX);
+		memcpy(buf, DEFAULT_INTERNATIONAL_PREFIX, offset);
+		break;
+	default:
+		break;
+	}
+
+	strncpy(&buf[offset], digits, size - (offset + 1));
+	buf[size - 1] = '\0';
+}
+
+#define isdn_get_number(num, buf) \
+	__isdn_get_number((const char *)(num)->Digit, (num)->TypNum, (char *)buf, sizeof(buf))
+
+
+/**
+ * \brief	The old call event handler (err, call message handler)
+ * \todo	This one must die!
+ */
+static L3INT ftdm_isdn_931_34(void *pvt, struct Q931_Call *call, Q931mes_Generic *msg, int mlen)
 {
 	ftdm_span_t *span = (ftdm_span_t *) pvt;
 	ftdm_isdn_data_t *isdn_data = span->signal_data;
 	Q931mes_Generic *gen = (Q931mes_Generic *) msg;
-	uint32_t chan_id = 0;
+	int chan_id = 0;
 	int chan_hunt = 0;
 	ftdm_channel_t *ftdmchan = NULL;
-	ftdm_caller_data_t *caller_data = NULL;
+//	ftdm_caller_data_t *caller_data = NULL;
 
 	if (Q931IsIEPresent(gen->ChanID)) {
 		Q931ie_ChanID *chanid = Q931GetIEPtr(gen->ChanID, gen->buf);
@@ -580,9 +769,30 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 
 	assert(span != NULL);
 	assert(isdn_data != NULL);
-	
+
+	/*
+	 * Support code for the new event handling system
+	 * Remove this as soon as we have the new api to set up calls
+	 */
+#ifdef __OLD__
+	if (gen->CRV) {
+		struct Q931_Call *call;
+
+		call = Q931GetCallByCRV(&isdn_data->q931, gen->CRV);
+		if (call && !Q931CallGetPrivate(call)) {
+			ftdm_log(FTDM_LOG_DEBUG, "Storing reference to current span in call %d [0x%x]\n", gen->CRV, gen->CRV);
+			Q931CallSetPrivate(call, span);
+		}
+	}
+#else
+	if (call && !Q931CallGetPrivate(call)) {
+		ftdm_log(FTDM_LOG_DEBUG, "Storing reference to current span in call %d [0x%x]\n", gen->CRV, gen->CRV);
+		Q931CallSetPrivate(call, span);
+	}
+#endif
 	ftdm_log(FTDM_LOG_DEBUG, "Yay I got an event! Type:[%02x] Size:[%d] CRV: %d (%#hx, CTX: %s)\n", gen->MesType, gen->Size, gen->CRV, gen->CRV, gen->CRVFlag ? "Terminator" : "Originator");
 
+#ifdef __TODO_OR_REMOVE__
 	if (gen->CRVFlag && (caller_data = isdn_data->outbound_crv[gen->CRV])) {
 		if (chan_id) {
 			caller_data->chan_id = chan_id;
@@ -603,9 +813,10 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 			caller_data->call_state = FTDM_CALLER_STATE_FAIL;
 			break;
 		}
-	
+
 		return 0;
 	}
+#endif
 
 	if (gen->CRVFlag) {
 		ftdmchan = isdn_data->channels_local_crv[gen->CRV];
@@ -630,7 +841,7 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 							ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_RESTART);
 						}
 						break;
-					case 1: 
+					case 1:
 						{ /* change status to "maintenance" */
 							ftdm_set_flag_locked(ftdmchan, FTDM_CHANNEL_SUSPENDED);
 							ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_SUSPENDED);
